Команда "Создать деталь"

From FreeCAD Documentation
Revision as of 18:50, 2 September 2022 by Evgeniy (talk | contribs) (Created page with "==Подробное описание==")

Создать деталь

Системное название
Std_Part
Расположение в меню
None
Верстаки
Все
Быстрые клавиши
Нет
Представлено в версии
0.17
См. также
Создать группу, Создать тело

Описание

Std Part (internally called App Part) is a general purpose container that keeps together a group of objects so that they can be moved together as a unit in the 3D view.

The Std Part element was developed to be the basic building block to create mechanical assemblies. In particular, it is meant to arrange objects that have a Part TopoShape, like Part Primitives, PartDesign Bodies, and other Part Features. The Std Part provides an Origin object with local X, Y, and Z axes, and standard planes, that can be used as reference to position the contained objects. In addition, Std Parts may be nested inside other Std Parts to create a big assembly from smaller sub-assemblies.

Although it is primarily intended for solid bodies, the Std Part can be used to manage any object that has a Placement property, so it can also contain Mesh Features, sketches, and other objects derived from the App GeoFeature class.

Do not confuse the PartDesign Body with the Std Part. The first one is a specific object used in the PartDesign Workbench, intended to model a single contiguous solid by means of PartDesign Features. On the other hand, the Std Part is not used for modelling, just to arrange different objects in space, with the intention to create assemblies.

The Std Part tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches. To group objects arbitrarily without considering their position, use Std Group; this object does not affect the placements of the elements that it contains, it is essentially just a folder that is used to keep the Tree view organized.

Left: elements inside a Std Part in the Tree view. Right: objects positioned in space, referred to the Origin of the Std Part.

Применение

  1. Press the Create part button.
  2. An empty Part is created and automatically becomes active.
  3. To add objects to the Part, select them in Tree view, and drag and drop them onto the Part.
  4. To remove objects from the Part, drag them out of the Part, and onto the document label at the top of the Tree view.
  5. Objects can also be added and removed by editing the ДанныеGroup property of the Part.

Примечания

  • An object can only belong to a single Part.
  • 3D operations like Part Boolean cannot be applied to Parts. For example, you cannot select two Parts, and perform a Part Fuse or Part Cut.

Свойства

The Std Part, internally called App Part (App::Part class), is derived from the App GeoFeature (App::GeoFeature class) and inherits all its properties. It also has several additional properties. Notably properties that help it manage information in the context of an assembly, for example, ДанныеType, ДанныеId, ДанныеLicense, ДанныеLicenseURL and ДанныеGroup.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Данные

Основные

  • ДанныеType (String): a description for this object. By default, it is an empty string "".
  • ДанныеMaterial (Link): the material for this object.
  • Данные (Hidden)Meta (Map): map with additional meta information. By default, it is empty {}.
  • ДанныеId (String): an identification or part number for this object. By default, it is an empty string "".
  • Данные (Hidden)Uid (UUID): the universally unique identifier (UUID) (128-bit number) of the object. This is assigned at creation time.
  • ДанныеLicense (String): a field to specify the license for this object. By default, it is an empty string "".
  • ДанныеLicenseURL (String): a field to specify the web address to the license or contract for this object. By default, it is an empty string "".
  • ДанныеColor (Color): a tuple of four floating point RGBA values (r,g,b,a) to define the color of the object; by default it is (1.0, 1.0, 1.0, 1.0), which is displayed as [255,255,255] on base 255, white color.
  • ДанныеPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • ДанныеAngle: the angle of rotation around the ДанныеAxis. By default, it is (zero degrees).
    • ДанныеAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • ДанныеPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • ДанныеLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.
  • Данные (Hidden)Label2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string that may include newlines. By default, it is an empty string "".
  • Данные (Hidden)Expression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • Данные (Hidden)Visibility (Bool): whether to display the object or not.
  • Данные (Hidden)Origin (Link): the App Origin object that is the positional reference for all elements listed in ДанныеGroup.
  • ДанныеGroup (LinkList): a list of referenced objects. By default, it is empty [].
  • Данные (Hidden)_ Group Touched (Bool): whether the group is touched or not.

Вид

Display Options

  • ВидDisplay Mode (Enumeration): Group.
  • ВидShow In Tree (Bool): if it is true, the object appears in the Tree view. Otherwise, it is set as invisible.
  • ВидVisibility (Bool): if it is true, the object appears in the 3D view; otherwise it is invisible. By default this property can be toggled on and off by pressing the Space bar in the keyboard.

Selection

  • ВидOn Top When Selected (Enumeration): Disabled (default), Enabled, Object, Element.
  • ВидSelection Style (Enumeration): Shape (default), BoundBox. If the option is Shape, the entire shape (vertices, edges, and faces) will be highlighted in the 3D view; if it is BoundBox only the bounding box will be highlighted.

Подробное описание

Активное состояние

An open document can contain multiple Parts. But only one Part can be active. The active Part is displayed in the tree view with the background color specified by the Active container value in the preferences editor (by default, light blue). It will also be shown with bold text.

To activate or de-activate a Part:

  • Double click on it on the Tree view, or
  • Open the context menu (right click) and select Toggle active part.

Document with two Std Parts, of which the second one is active.

Начало координат

The Origin consists of the three standard axes (X, Y, Z) and three standard planes (XY, XZ and YZ). Sketches and other objects can be attached to these elements when creating them.

Left: Part Origin in the Tree view. Right: representation of the Origin elements in the 3D view.

Note: the Origin is an App Origin object (App::Origin class), while the axes and planes are objects of type App::Line and App::Plane respectively. Each of these elements can be hidden and unhidden individually with the Space bar; this is useful to choose the correct reference when creating other objects.

Note 2: all elements inside the Part are referenced to the Part's Origin which means that the Part can be moved and rotated in reference to the global coordinate system without affecting the placement of the elements inside.

Visibility Management

The Part's visibility supersedes the visibility of any object it contains. If the Part is hidden, the objects it contains will be hidden as well, even if their individual ВидVisibility property is set to true. If the Part is visible, then each object's ВидVisibility determines whether the object is shown or not.

The visibility of the Std Part determines whether the objects grouped under it are shown in the 3D view or not. Left: the Part is hidden, so none of the objects will be shown in the 3D view. Right: the Part is visible, so each object controls its own visibility.

Программирование

Общие сведения о добавлении объектов в документ смотрите в разделе Конструктивный элемент верстака Part.

A Std Part (App Part) is created with the addObject() method of the document. Once a Part exists, other objects can be added to it with the addObject() or addObjects() methods.

import FreeCAD as App

doc = App.newDocument()
part = App.ActiveDocument.addObject("App::Part", "Part")

obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("Part::Box", "Box")

part.addObjects([obj1, obj2])
App.ActiveDocument.recompute()

You cannot create a scripted App::Part. However, you can add App::Part behavior to a scripted Part::FeaturePython object by using the following code:

class MyGroup(object):
    def __init__(self, obj=None):
        self.Object = obj
        if obj:
            self.attach(obj)

    def __getstate__(self):
        return

    def __setstate__(self, _state):
        return

    def attach(self, obj):
        obj.addExtension("App::OriginGroupExtensionPython")
        obj.Origin = FreeCAD.ActiveDocument.addObject("App::Origin", "Origin")

    def onDocumentRestored(self, obj):
        self.Object = obj

class ViewProviderMyGroup(object):
    def __init__(self, vobj=None):
        if vobj:
            vobj.Proxy = self
            self.attach(vobj)
        else:
            self.ViewObject = None

    def attach(self, vobj):
        vobj.addExtension("Gui::ViewProviderOriginGroupExtensionPython")
        self.ViewObject = vobj

    def __getstate__(self):
        return None

    def __setstate__(self, _state):
        return None

App.ActiveDocument.addObject("Part::FeaturePython",
                             "Group",
                             group.MyGroup(),
                             group.ViewProviderMyGroup(),
                             True)